﻿; Image Direct Memory.pbi

Structure T_RGBA
B.a
G.a
R.a
A.a
EndStructure

Macro RGB_B(color)
((color & $FF0000) >> 16)
EndMacro

Macro RGB_G(color)
((color & $FF00) >> 8)
EndMacro

Macro RGB_R(color)
(color & $FF)
EndMacro

Macro RGB_Mix (r, g, b)
((((b) << 8 + (g)) << 8) + (r))
EndMacro

Macro CopyPixel32 (iXs, iYs, iXd, iYd, iBufferPitchSrc, iBufferPitchDest, ptRGBAs, ptRGBAd, pMemSrc, pMemDest)
ptRGBAs = pMemSrc  + (iYs) * iBufferPitchSrc + (iXs) << 2
ptRGBAd = pMemDest + (iYd) * iBufferPitchDest + (iXd) << 2       
ptRGBAd\R = ptRGBAs\R
ptRGBAd\G = ptRGBAs\G
ptRGBAd\B = ptRGBAs\B       
ptRGBAd\A = ptRGBAs\A
EndMacro

Macro CopyPixel24 (iXs, iYs, iXd, iYd, iBufferPitchSrc, iBufferPitchDest, ptRGBAs, ptRGBAd, pMemSrc, pMemDest)
ptRGBAs = pMemSrc  + (iYs) * iBufferPitchSrc + (iXs) * 3
ptRGBAd = pMemDest + (iYd) * iBufferPitchDest + (iXd) * 3       
ptRGBAd\R = ptRGBAs\R
ptRGBAd\G = ptRGBAs\G
ptRGBAd\B = ptRGBAs\B       
EndMacro

Macro ReadPixel32 (iX, iY, iBufferPitchSrc, ptRGBA, pMemSrc)
ptRGBA = pMemSrc + (iY) * iBufferPitchSrc + (iX) << 2
EndMacro

Macro ReadPixel24 (iX, iY, iBufferPitchSrc, ptRGBA, pMemSrc)
ptRGBA = pMemSrc + (iY) * iBufferPitchSrc + (iX) * 3
EndMacro

Macro WritePixel32 (tPixel, iX, iY, iBufferPitchDest, ptRGBA, pMemDest)
ptRGBA = pMemDest + (iY) * iBufferPitchDest + (iX) << 2                       
ptRGBA\R = tPixel\R
ptRGBA\G = tPixel\G
ptRGBA\B = tPixel\B
ptRGBA\A = tPixel\A
EndMacro

Macro WritePixel24 (tPixel, iX, iY, iBufferPitchDest, ptRGBA, pMemDest)
ptRGBA = pMemDest + (iY) * iBufferPitchDest + (iX) * 3
ptRGBA\R = tPixel\R
ptRGBA\G = tPixel\G
ptRGBA\B = tPixel\B
EndMacro
; IDE Options = PureBasic 4.51 (Windows - x86)
; Folding = --
; EnableUnicode
; EnableXP
; EnableOnError
; EnableCompileCount = 0
; EnableBuildCount = 0
; EnableExeConstant